%global cpan_version 2.21

Summary:        Perl interpreter-based threads
Name:           perl-threads
Version:        2.27
Release:        5%{?dist}
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/threads
Source0:        https://cpan.metacpan.org/authors/id/J/JD/JDHEDDEN/threads-%{cpan_version}.tar.gz

# From perl 5.36.0
Patch0001:		0001-threads-2.21-upgrade-to-2.27.patch	

BuildRequires:  coreutils findutils gcc make perl-generators perl-interpreter
BuildRequires:  perl-devel perl(Config) perl(File::Spec) perl(strict) perl(Carp)
BuildRequires:  perl(warnings) perl(overload) perl(XSLoader) perl(blib) perl(Cwd)
BuildRequires:  perl(ExtUtils::testlib) perl(File::Path) perl(IO::File) perl(POSIX)
BuildRequires:  perl(Hash::Util) perl(Thread::Queue) perl(Thread::Semaphore)
BuildRequires:  perl(threads::shared)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
Requires:       perl(Carp)

%description
The "interpreter-based threads" provided by Perl are not the fast, 
lightweight system for multitasking that one might expect or hope 
for. Threads are implemented in a way that make them easy to misuse. 
Few people know how to use them correctly or will be able to provide 
help.

%prep
%autosetup -n threads-%{cpan_version} -p1
chmod -x examples/*

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1 OPTIMIZE="$RPM_OPT_FLAGS"
%{make_build}

%install
%{make_install}
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes examples README
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/threads*
%{_mandir}/man3/*

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.27-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 17 2023 Xiaojie Chen <jackxjchen@tencent.com> - 2.27-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.27-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.27-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Sep 5 2022 Xiaojie Chen <jackxjchen@tencent.com> - 2.27-1
- Initial build
